package Ha;

import java.io.*;
public class XmlChecks {
    public static int Manifest_Debug(String path) {
        // 디버그 모드 확인 (AndroidManifest.xml 파일에서 확인 가능)
        // 디버그 모드면 외부에서 임의의 코드를 주입 가능, 개발시에만 사용해야함
        int num = 0;
        int weak = 0;
        try {
            String check = "android:debuggable=\"true\"";

            File f = new File(path);
            FileReader fr = new FileReader(String.valueOf(f));
            BufferedReader bufr = new BufferedReader(fr);
            String line = "";
            while ((line = bufr.readLine()) != null) {
                if (line.contains(check))
                    // 라인 중 android:debuggable="true" 포함한 라인 찾음
                    System.out.println("디버그 모드 작동 중 -> 취약");
                num++;
                if (num > 0) {
                    OpenTable ot = new OpenTable();
                    ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' 디버그 모드 확인',' 디버그 모드 작동 중 ') ");
                    break;

                }
            }
            bufr.close();
        } catch (FileNotFoundException e) {
            System.out.println("파일을 찾을 수 없음");
        } catch (IOException e) {
            System.out.println(e);
        }
        if(num>0)

            return 1;
        else
            return 0;
    }

    public static int Manifest_Backup(String path) {
        // 백업 허용 확인 (AndroidManifest.xml 파일에서 확인 가능)
        // 악의적 사용자가 adb를 사용하여 앱의 개인 데이터를 자신의 PC에 가져올 수 있음.
        int num = 0;
        try {
            String check = "android:allowBackup=\"true\"";

            File f = new File(path);
            FileReader fr = new FileReader(String.valueOf(f));
            BufferedReader bufr = new BufferedReader(fr);
            String line = "";
            while ((line = bufr.readLine()) != null) {
                if (line.contains(check))
                    // 라인 중 android:allowBackup="true" 포함한 라인 찾음
                    System.out.println("adb를 통해 백업 허용 중 -> 취약");
                num++;
                if (num > 0) {
                    OpenTable ot = new OpenTable();
                    ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' 백업 허용 확인',' adb를 통해 백업 허용 ') ");
                    break;

                }
            }
            bufr.close();
        } catch (FileNotFoundException e) {
            System.out.println("파일을 찾을 수 없음");
        } catch (IOException e) {
            System.out.println(e);
        }
        if(num>0)
            return 1;
        else
            return 0;
    }

    public static int Manifest_Location(String path) {
        // 사용자의 위치 정보 접근 확인 (AndroidManifest.xml 파일에서 확인 가능)
        // Wi-Fi와 같은 네트워크 위치 소스를 통해 위치 얻어짐. 기본 권한으로 설정되어 있으면 위험함.
        int num = 0;
        try {
            String check = "android.permission.ACCESS_COARSE_LOCATION";

            File f = new File(path);
            FileReader fr = new FileReader(String.valueOf(f));
            BufferedReader bufr = new BufferedReader(fr);
            String line = "";
            while ((line = bufr.readLine()) != null) {
                if (line.contains(check))
                    // 라인 중 android.permission.ACCESS_COARSE_LOCATION 포함한 라인 찾음
                    System.out.println("위치 정보 접근 허용 -> 취약");
                num++;
                if (num > 0) {
                    OpenTable ot = new OpenTable();
                    ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' 사용자의 위치 정보 접근 확인',' 위치 정보 접근 허용 ') ");
                    break;

                }
            }
            bufr.close();
        } catch (FileNotFoundException e) {
            System.out.println("파일을 찾을 수 없음");
        } catch (IOException e) {
            System.out.println(e);
        }
        if(num>0)
            return 1;
        else
            return 0;
    }

    public static int Manifest_Phone(String path) {
        // Phone 권한 확인 (AndroidManifest.xml 파일에서 확인 가능)
        // 장치의 전화번호, 네트워크정보, 진행중인 통화의 상태 읽어오기, 사용자의 통화 기록 읽기 가능
        int num = 0;
        try {
            String check = "android.permission.READ_CALL_LOG";
            String check2 = "android.permission.READ_PHONE_STATE";

            File f = new File(path);
            FileReader fr = new FileReader(String.valueOf(f));
            BufferedReader bufr = new BufferedReader(fr);
            String line = "";
            while ((line = bufr.readLine()) != null) {
                if (line.contains(check))
                    // 라인 중 android.permission.READ_CALL_LOG 포함한 라인 찾음
                    System.out.println("사용자의 통화 기록 읽기 허용 -> 취약");
                num++;
                if (num > 0) {
                    OpenTable ot = new OpenTable();
                    ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' Phone 권한 확인',' 장치의 전화 번호, 네트워크 정보, 진행중인 통화의 상태 읽어오기 허용 ') ");
                    break;

                }
                if (line.contains(check2))
                    // 라인 중 android.permission.READ_PHONE_STATE 포함된 라인 찾음
                    System.out.println("장치의 전화 번호, 네트워크 정보, 진행중인 통화의 상태 읽어오기 허용 -> 취약");
                num++;
                if (num > 0) {
                    OpenTable ot = new OpenTable();
                    ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' Phone 권한 확인',' 사용자의 통화 기록 읽기 허용 ') ");
                    break;
                    //String weak1 = "VALUES(' 상', ' 디버그 모드 확인',' 디버그 모드 작동 중 ') ";
                }

            }
            bufr.close();
        } catch (FileNotFoundException e) {
            System.out.println("파일을 찾을 수 없음");
        } catch (IOException e) {
            System.out.println(e);
        }
        if(num>0)
            return 1;
        else
            return 0;
    }

    public static int Manifest_Activity(String path) {
        // 액티비티 컴포넌트 확인 (AndroidManifest.xml 파일에서 확인 가능)
        // 다른 에플리케이션의 Activity를 실행 할 수 있음.
        int num = 0;
        try {
            int i = 0;
            int count = 0;
            String check = "activity android:exported=\"true\"";

            File f = new File(path);
            FileReader fr = new FileReader(String.valueOf(f));
            BufferedReader bufr = new BufferedReader(fr);
            String line = "";
            while ((line = bufr.readLine()) != null) {

                if (line.contains(check))
                    // 라인 중 android:exported="true" 포함한 라인 찾음
                    //System.out.println("다른 애플리케이션의 Activity 실행가능 -> 취약");
                    i++;
                count = i;
            }
            if (i > 0)
            {
                System.out.println("노출된 Activity 갯수 : "+count+" -> 취약");
                num++;
                if (num > 0) {
                    OpenTable ot = new OpenTable();
                    ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' 액티비티 컴포넌트 확인',' 노출된 Activity 갯수 :"+ count +"') ");
                }
            }
            bufr.close();
        } catch (FileNotFoundException e) {
            System.out.println("파일을 찾을 수 없음");
        } catch (IOException e) {
            System.out.println(e);
        }
        if(num>0)
            return 1;
        else
            return 0;
    }

    public static int find(String path){
        //xml파일에서 provider 검색 함수
        String word = "(?i).*provider.*";
        int num=0;
        try {
            BufferedReader reader = new BufferedReader(new FileReader(path));
            String s;

            int line =1;

            while ((s = reader.readLine()) != null) {
                if (s.matches(word)){
                    System.out.println(line + " : " + s);
                    num++;
                }
                line++; }
        } catch (FileNotFoundException e) { e.printStackTrace(); }
        catch (IOException e) { e.printStackTrace(); }
        if(num>0)
            return 1; //content provide 취약점이 있으면 1 return
        else
            return 0;
    }

    public static int Manifest_Provider(String path) {
        // 수출 업체
        // 내보낸 공급자를 찾았습니다. 다른 응용 프로그램에서 사용할 수 있습니다.
        int num = 0;
        try {
            String check = "<provider";

            File f = new File(path);
            FileReader fr = new FileReader(String.valueOf(f));
            BufferedReader bufr = new BufferedReader(fr);
            String line = "";
            while ((line = bufr.readLine()) != null) {
                if (line.contains(check))
                    System.out.println("수출 업체 취약"); }
            num++;
            bufr.close();
        } catch (FileNotFoundException e) {
            System.out.println("파일을 찾을 수 없음");
        } catch (IOException e) {
            System.out.println(e);
        }
        if(num>0) {
            OpenTable ot = new OpenTable();
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 중', ' 수출 업체',' 수출 업체 취약 ') ");
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 중', ' 수출 업체2',' 다른 응용 프로그램이 사용 가능한 공급자 발견 ') ");
            return 1;
        }
        else
            return 0;
    }

    public static int Manifest_Receiver(String path) {
        // 수출 수신기
        // 내보낸 수신기를 찾았습니다. 다른 응용 프로그램에서 사용할 수 있습니다.
        int num = 0;
        try {
            String check = " <receiver";

            File f = new File(path);
            FileReader fr = new FileReader(String.valueOf(f));
            BufferedReader bufr = new BufferedReader(fr);
            String line = "";
            while ((line = bufr.readLine()) != null) {
                if (line.contains(check))
                    System.out.println("수신기 취약");
                num++;
            }
            bufr.close();
        } catch (FileNotFoundException e) {
            System.out.println("파일을 찾을 수 없음");
        } catch (IOException e) {
            System.out.println(e);
        }
        if(num>0){
            OpenTable ot = new OpenTable();
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 중', ' 수출 수신기',' 수신기 취약 ') ");
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 중', ' 수출 수신기2',' 다른 응용 프로그램이 사용 가능한 수신기 발견 ') ");
            return 1;
        }
        else
            return 0;
    }

    public static int Manifest_Accounts(String path) {
        // 계정 가져 오기 권한
        // 앱이 전화로 알려진 계정 목록을 가져올 수 있도록 허용합니다. 여기에는 설치 한 응용 프로그램에서 만든 계정이 포함될 수 있습니다. 권한이 실제로 필요한지 확인하십시오.
        int num = 0;
        try {
            String check = "android.permission.GET_ACCOUNTS";

            File f = new File(path);
            FileReader fr = new FileReader(String.valueOf(f));
            BufferedReader bufr = new BufferedReader(fr);
            String line = "";
            while ((line = bufr.readLine()) != null) {
                if (line.contains(check))
                    System.out.println("계정 취약");
                num++; }
            bufr.close();
        } catch (FileNotFoundException e) {
            System.out.println("파일을 찾을 수 없음");
        } catch (IOException e) {
            System.out.println(e);
        }
        if(num>0){
            OpenTable ot = new OpenTable();
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' 계정 가져오기 권한',' 계정 취약 ') ");
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' 계정 가져오기 권한2',' 전화로 알려진 계정 목록 취득 가능 ') ");
            return 1;
        }
        else
            return 0;
    }

    public static int Manifest_Internet(String path) {
        // 인터넷 허가
        // 앱이 네트워크 소켓을 만들고 사용자 지정 네트워크 프로토콜을 사용할 수 있도록 허용합니다. 브라우저 및 기타 응용 프로그램은 인터넷으로 데이터를 전송하는 수단을 제공하므로 인터넷으로 데이터를 전송하는 데이 권한이 필요하지 않습니다. 권한이 실제로 필요한지 확인하십시오.
        int num = 0;
        try {
            String check = "android.permission.INTERNET";

            File f = new File(path);
            FileReader fr = new FileReader(String.valueOf(f));
            BufferedReader bufr = new BufferedReader(fr);
            String line = "";
            while ((line = bufr.readLine()) != null) {
                if (line.contains(check))
                    System.out.println("인터넷 허가 취약");
                num++;    }
            bufr.close();
        } catch (FileNotFoundException e) {
            System.out.println("파일을 찾을 수 없음");
        } catch (IOException e) {
            System.out.println(e);
        }
        if(num>0){
            OpenTable ot = new OpenTable();
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' 인터넷 허가',' 인터넷 허가 취약 ') ");
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' 인터넷 허가2',' 앱이 네트워크 소켓 및 사용자 지정 네트워크 프로토콜 사용 가능 ') ");
            return 1;
        }
        else
            return 0;
    }

    public static int Manifest_Contacts(String path) {
        // 연락처 읽기 권한
        // 앱이 전화, 이메일 또는 특정 방식으로 다른 사람과 통신 한 빈도를 비롯하여 휴대 전화에 저장된 연락처에 대한 데이터를 읽을 수 있도록 허용합니다. 이 권한을 통해 앱은 연락처 데이터를 저장할 수 있으며 악성 앱은 사용자 모르게 연락처 데이터를 공유 할 수 있습니다.
        int num = 0;
        try {
            String check = "android.permission.READ_CONTACTS";

            File f = new File(path);
            FileReader fr = new FileReader(String.valueOf(f));
            BufferedReader bufr = new BufferedReader(fr);
            String line = "";
            while ((line = bufr.readLine()) != null) {
                if (line.contains(check))
                    System.out.println("연락처 취약");
                num++; }
            bufr.close();
        } catch (FileNotFoundException e) {
            System.out.println("파일을 찾을 수 없음");
        } catch (IOException e) {
            System.out.println(e);
        }
        if(num>0){
            OpenTable ot = new OpenTable();
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' 연락처 읽기 권한',' 연락처 취약 ') ");
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' 연락처 읽기 권한2',' 앱이 전화에 저장된 연락처 읽기 허용 ') ");
            return 1;
        }
        else
            return 0;
    }

    public static int Manifest_Rstorage(String path) {
        // 외부 저장소 읽기
        // 앱이 SD 카드의 내용을 읽을 수 있도록 허용합니다
        int num = 0;
        try {
            String check = "android.permission.READ_EXTERNAL_STORAGE";

            File f = new File(path);
            FileReader fr = new FileReader(String.valueOf(f));
            BufferedReader bufr = new BufferedReader(fr);
            String line = "";
            while ((line = bufr.readLine()) != null) {
                if (line.contains(check))
                    System.out.println("외부 저장소 읽기 취약");
                num++; }
            bufr.close();
        } catch (FileNotFoundException e) {
            System.out.println("파일을 찾을 수 없음");
        } catch (IOException e) {
            System.out.println(e);
        }
        if(num>0){
            OpenTable ot = new OpenTable();
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' 외부 저장소 읽기',' 외부 저장소 읽기 취약 ') ");
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' 외부 저장소 읽기2',' 앱이 SD카드 내용 읽기 허용') ");
            return 1;
        }
        else
            return 0;
    }

    public static int Manifest_Wstorage(String path) {
        // 외부 저장소 쓰기
        // 앱이 SD 카드에 쓸 수 있도록 허용합니다.
        int num = 0;
        try {
            String check = "android.permission.WRITE_EXTERNAL_STORAGE";

            File f = new File(path);
            FileReader fr = new FileReader(String.valueOf(f));
            BufferedReader bufr = new BufferedReader(fr);
            String line = "";
            while ((line = bufr.readLine()) != null) {
                if (line.contains(check))
                    System.out.println("외부 저장소 쓰기 취약");
                num++; }
            bufr.close();
        } catch (FileNotFoundException e) {
            System.out.println("파일을 찾을 수 없음");
        } catch (IOException e) {
            System.out.println(e);
        }
        if(num>0){
            OpenTable ot = new OpenTable();
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' 외부 저장소 쓰기',' 외부 저장소 쓰기 취약 ') ");
            ot.update("INSERT INTO result2 (Grade,Name,Content)" + "VALUES(' 상', ' 외부 저장소 쓰기2',' 앱이 SD카드 내용 쓰기 허용 ') ");
            return 1;
        }
        else
            return 0;
    }
}
